import TS from 'typescript/lib/tsserverlibrary';

interface Modules {
  typescript: typeof TS
}

interface PluginConfig {
  features: {
    diagnostics: boolean | Array<'semantic' | 'syntactic' | 'suggestion'>
    organizeImports: boolean
    quickInfo: boolean
    rename: boolean
    refactor: boolean
    goto: boolean
    tagCompletions: boolean | Array<'html' | 'svg'>
  }
  /** A file to communicate with extension? */
  extensionSocketFileName?: string
}

declare type PluginModule = TS.server.PluginModule;
declare function init({ typescript }: Modules): TS.server.PluginModule;

export default init;
export { Modules, PluginConfig, PluginModule };
